"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    generateGuard: function() {
        return generateGuard;
    },
    isGuardTest: function() {
        return isGuardTest;
    },
    isGuardTests: function() {
        return isGuardTests;
    },
    isGuardTestGroups: function() {
        return isGuardTestGroups;
    }
});
var _castArray = /*#__PURE__*/ _interop_require_default(require("lodash/castArray"));
var _every = /*#__PURE__*/ _interop_require_default(require("lodash/every"));
var _isArray = /*#__PURE__*/ _interop_require_default(require("lodash/isArray"));
var _isBoolean = /*#__PURE__*/ _interop_require_default(require("lodash/isBoolean"));
var _isFunction = /*#__PURE__*/ _interop_require_default(require("lodash/isFunction"));
var _over = /*#__PURE__*/ _interop_require_default(require("lodash/over"));
var _some = /*#__PURE__*/ _interop_require_default(require("lodash/some"));
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
var generateGuard = function() {
    for(var _len = arguments.length, testGroups = new Array(_len), _key = 0; _key < _len; _key++){
        testGroups[_key] = arguments[_key];
    }
    if (testGroups.length < 1) {
        return function(maybe) {
            return false;
        };
    }
    return function(maybe) {
        return (0, _some.default)(testGroups, function(tests) {
            var safeTests = (0, _castArray.default)(tests);
            if (safeTests.length < 1) {
                return false;
            }
            return (0, _every.default)(_over.default.apply(void 0, _to_consumable_array(safeTests))(maybe), function(result) {
                return result === true;
            });
        });
    };
};
var isGuardTest = generateGuard([
    _isFunction.default,
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    function(maybe) {
        return (0, _isFunction.default)(maybe) && (0, _isBoolean.default)(maybe("something"));
    }
]);
var isGuardTests = generateGuard([
    _isArray.default,
    function(maybe) {
        return (0, _every.default)(maybe, isGuardTest);
    }
]);
var isGuardTestGroups = generateGuard([
    _isArray.default,
    function(maybe) {
        return (0, _every.default)(maybe, function(testGroup) {
            return isGuardTest(testGroup) || isGuardTests(testGroup);
        });
    }
]);
